"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const BaseReactCustomElement_1 = __importDefault(require("./BaseReactCustomElement"));
const createReactCustomElement = (Component, useShadowDOM = true) => {
    return class ReactCustomElement extends BaseReactCustomElement_1.default {
        constructor() {
            super();
            this.renderRoot = this.createRenderRoot();
        }
        connectedCallback() {
            this.renderApp();
        }
        renderApp() {
            react_dom_1.default.render(react_1.default.createElement(Component, { renderRoot: this.renderRoot }), this.renderRoot);
        }
        disconnectedCallback() {
            react_dom_1.default.unmountComponentAtNode(this.renderRoot);
        }
        createRenderRoot() {
            if (!useShadowDOM) {
                return this;
            }
            if (window.ShadyDOM) {
                return this;
            }
            return this.attachShadow({ mode: 'open' });
        }
    };
};
exports.default = createReactCustomElement;
//# sourceMappingURL=ReactCustomElement.js.map