"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_dom_1 = __importDefault(require("react-dom"));
const ReactCustomElement_1 = __importDefault(require("./ReactCustomElement"));
const createReactCustomElementWithProps = (Component, properties, useShadowDOM = true) => {
    return class ReactCustomElementWithProps extends ReactCustomElement_1.default(Component, useShadowDOM) {
        constructor() {
            super();
            this.props = {};
            this.hasConnected = false;
        }
        static get observedAttributes() {
            return properties || [];
        }
        ;
        attributeChangedCallback(name, oldValue, newValue) {
            if (oldValue === newValue) {
                return;
            }
            const propName = this.getPropName(name);
            this.props[propName] = newValue;
            if (this.hasConnected) {
                Promise.resolve().then(() => {
                    this.renderApp();
                });
            }
        }
        connectedCallback() {
            this.hasConnected = true;
            super.connectedCallback();
        }
        renderApp() {
            react_dom_1.default.render(react_1.default.createElement(Component, Object.assign({ renderRoot: this.renderRoot }, this.props)), this.renderRoot);
        }
        getPropName(attrName) {
            return attrName.replace(/-([a-z])/g, (g) => g[1].toUpperCase());
        }
    };
};
exports.default = createReactCustomElementWithProps;
//# sourceMappingURL=ReactCustomElementWithProps.js.map